// this is the "parser" for the 'master-drummer' sequence used
// in the kb5 patches

outlets = 2;

var notes = new Array();
var curnote = 0;

var speed = 200;

var mode1 = [ 60, 67, 72 ]; // C - G - Coct; signals mode 1
var mode2 = [ 72, 77, 72 ]; // C - F - C; signals mode 2


function msg_int(val) {
	// note 48 resets note parser
	if (val == 48) {
		curnote = 0;
		return;
	}
	
	if (val == 95) {
		speed = speed + 10;
		outlet(1, speed);
		return;
	}
	if (val == 96) {
		speed = speed - 10;
		outlet(1, speed);
		return;
	}
	
	notes[curnote] = val;
	curnote++;
	if (curnote == 3) {
		checknotes();
		curnote = 0;
	}
}

function checknotes() {
	// mode 1
	if (notes[0] == mode1[0]) {
		if (notes[1] == mode1[1]) {
			if (notes[2] == mode1[2]) {
				outlet(0, "mode", 1);
			}
		}
	}
	
	// mode 2
	if (notes[0] == mode2[0]) {
		if (notes[1] == mode2[1]) {
			if (notes[2] == mode2[2]) {
				outlet(0, "mode", 2);
			}
		}
	}
}

